unit Demo3Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AHWord97,jwWord97,
  StdCtrls, ExtCtrls, OleCtnrs, Db, DBTables;

type
  TfrmDemo3 = class(TForm)
    btnInsert: TButton;
    btnOpenWord: TButton;
    btnCloseWord: TButton;
    btnOpenDoc: TButton;
    btnClose: TButton;
    Shape1: TShape;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    btnCloseDoc: TButton;
    Database1: TDatabase;
    qryCustomer: TQuery;
    qryOrders: TQuery;
    srcCustomer: TDataSource;
    procedure btnOpenWordClick(Sender: TObject);
    procedure btnCloseWordClick(Sender: TObject);
    procedure btnInsertClick(Sender: TObject);
    procedure btnOpenDocClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCloseDocClick(Sender: TObject);
  private
    WrdApp : TWordApp;
    WrdDoc : TWordDoc;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDemo3: TfrmDemo3;

implementation

uses
  Word_TLB;

{$R *.DFM}

procedure TfrmDemo3.btnOpenWordClick(Sender: TObject);
begin
  WrdApp := TWordApp.Create (True);
  with WrdApp do
  begin
    Visible := True;
    DisableSystemCloseBox;
  end;
  btnOpenDoc.Enabled := True;
  btnOpenDoc.SetFocus;
  btnCloseWord.Enabled := True;
  btnOpenWord.Enabled := False;
end;

procedure TfrmDemo3.btnOpenDocClick(Sender: TObject);
begin
	 WrdDoc := TWordDoc.CreateOpenDoc (WrdApp, ExtractfilePath(ParamStr(0))+'Test3.Doc');
	 btnInsert.Enabled := True;
	 btnInsert.SetFocus;
  btnCloseDoc.Enabled := True;
	 btnOpenDoc.Enabled := False;
end;

procedure TfrmDemo3.btnInsertClick(Sender: TObject);
begin
  ProcessBookmarks (WrdDoc, qryCustomer);
  ProcessTables (WrdDoc, qryOrders);
  ProcessTables2 (WrdDoc, qryOrders);
  btnCloseDoc.SetFocus;
end;

procedure TfrmDemo3.btnCloseDocClick(Sender: TObject);
begin
  if Assigned (wrdDoc) then
  begin
    WrdDoc.CloseDoc (wdDoNotSaveChanges);
    WrdDoc := nil;
  end;
  btnCloseDoc.Enabled := False;
  btnOpenDoc.Enabled := True;
  btnCloseWord.SetFocus;
end;

procedure TfrmDemo3.btnCloseWordClick(Sender: TObject);
begin
  if Assigned (WrdApp) then
  begin
    WrdApp.CloseApp (wdDoNotSaveChanges);
    WrdApp := nil;
  end;
  btnOpenWord.Enabled := True;
  btnOpenDoc.Enabled := False;
  btnCloseDoc.Enabled := False;
  btnInsert.Enabled := False;
  btnCloseWord.Enabled := False;
  btnClose.SetFocus;
end;

procedure TfrmDemo3.btnCloseClick(Sender: TObject);
begin
	 Close
end;

procedure TfrmDemo3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	 if Assigned (WrdApp) then WrdApp.Free;
end;

end.